#include "rwmake.ch"      

User Function BOLCEFC()
***********************

SetPrvt("AAC,ACRA,CNOMEREL,CFILE,CSAVSCR1,CSAVCUR1")
SetPrvt("CSAVROW1,CSAVCOL1,CSAVCOR1,ANOTA,CALIAS,CSAVSCR3")
SetPrvt("MV_PAR01,MV_PAR02,MV_PAR03,MV_PAR04,MV_PAR05,MV_PAR06,MV_PAR07,MV_PAR08,MV_PAR09,MV_PAR10,CCOLOR")
SetPrvt("CTELA,AFILE,CSAVSCR,I,CSAVCOR,NOPCFILE")
SetPrvt("NOPCA,NTREGS,NMULT,NANT,NATU,NCNT")
SetPrvt("NTOTPORCEN,CSAV20,CSAV7,NDIA,CBARRA,CLINHA,cBarraImp,cBarraFim")
SetPrvt("NDIGITO,CCAMPO,NCONT,NVAL,instr1,instr2,cBarraImp4,X,NOSSONUM,cCondicao")

/*/
+------------+----------+-------+-------------------+------+---------------+
|  Descricao | Programa de Impressao de BOLETOS c/ Codigo de Barras        |
|            | para a Caixa Economica Federal                              |
+------------+-------------------------------------------------------------+
|  Uso       | Cassella                                                    |
+------------+-------------------------------------------------------------+
| Manutencao : Pedro Cassella 04/01/2010                                   |
|  VERIFICAR O INDICE 5 NO SE1: E1_FILIAL+E1_NUMBOR                        |
|  Criar campos : SE1 - E1_IMPRESS C 1                                     |
|                 Este campo ser utilizado para re-impresso do boleto    |
|                 Se estiver com "S" no gera novo NossoNumero             |
|  Criar Parametro : MV_BOLCEFC  Caracter 8 posies                       |                              |
|  Criar perguntas no SX1 conforme DBF em anexo                            |
|  Verificar informaes de conta e empresa no fonte                       |
|                                                                          |
+--------------------------------------------------------------------------+
/*/

//+--------------------------------------------------------------+
//| Define Variaveis                                             |
//+--------------------------------------------------------------+

Private nLastKey     := 0
Private vFrete      := 0
Private cPerguntas   := .F.
Private oFont, cCode
Private cBarraFim
cBarraImp := space(50)
nHeight:=15
lBold:= .F.
lUnderLine:= .F.
lPixel:= .T.
lPrint:=.F.
nSedex := 1
MsgInstr01	:= " "
MsgInstr02	:= " "
MsgInstr03	:= " "
MsgInstr04	:= " "
nossonum := " "
lNew:=.F.

oFont1 := TFont():New( "Times New Roman",,08,,.t.,,,,,.f. )
oFont2 := TFont():New( "Times New Roman",,10,,.t.,,,,,.f. )
oFont3 := TFont():New( "Times New Roman",,12,,.t.,,,,,.f. )
oFont4 := TFont():New( "Times New Roman",,14,,.t.,,,,,.f. )
oFont5 := TFont():New( "Times New Roman",,16,,.t.,,,,,.f. )
oFont6 := TFont():New( "HAETTENSCHWEILLER",,10,,.t.,,,,,.f. )
oFont8 := TFont():New( "Free 3 of 9" ,,44,,.t.,,,,,.f. )
oFont10:= TFont():New( "Free 3 of 9" ,,38,,.t.,,,,,.f. )
oFont11:= TFont():New( "Courier New" ,,10,,.t.,,,,,.f. )
oFont12:= TFont():New( "Courier New" ,,09,,.t.,,,,,.f. )
oFont13:= TFont():New( "Arial"       ,,06,,.f.,,,,,.f. )
oFont14:= TFont():New( "Arial"       ,,09,,.F.,,,,,.f. )
oFont15:= TFont():New( "Arial"       ,,10,,.t.,,,,,.f. )
oFont16:= TFont():New( "Arial"       ,,12,,.f.,,,,,.f. )
oFont17:= TFont():New( "Arial"       ,,14,,.T.,,,,,.f. )
oFont18:= TFont():New( "Arial"       ,,09,,.T.,,,,,.f. )
oFont19:= TFont():New( "Arial"       ,,22,,.t.,,,,,.f. )
oFont20:= TFont():New( "Arial Black" ,,16,,.t.,,,,,.f. )
oFont21:= TFont():New( "Arial"       ,,18,,.t.,,,,,.f. )
oFont22:= TFont():New( "Times New Roman",,15.5,,.t.,,,,,.f. )
oFont23:= TFont():New( "Arial Black"    ,,15.7,,.t.,,,,,.f. )
oFont24:= TFont():New( "Arial"          ,,07,,.T.,,,,,.f. )
oFont25:= TFont():New( "Times New Roman",,36,,.T.,,,,,.f. )
          
aRegistros:={}
cPerg   := padr("BOLCAX",10,' ')
/*
// Grupo/Ordem/Pergunta/Variavel/Tipo/Tamanho/Decimal/Presel/GSC/Valid/Var01/Def01/Cnt01/Var02/Def02/Cnt02/Var03/Def03/Cnt03/Var04/Def04/Cnt04/Var05/Def05/Cnt05
AADD(aRegistros,{cPerg,"01","Prefixo            ?","","","mv_ch1","C",03,0,0,"G","","mv_par01","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"02","Do titulo          ?","","","mv_ch2","C",06,0,0,"G","","mv_par02","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"03","Ate titulo         ?","","","mv_ch3","C",06,0,0,"G","","mv_par03","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"04","Da parcela         ?","","","mv_ch4","C",01,0,0,"G","","mv_par04","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"05","Ate a parcela      ?","","","mv_ch5","C",01,0,0,"G","","mv_par05","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"06","Filtra por         ?","","","mv_ch6","N",01,0,0,"C","","mv_par06","Numero","","","","","Bordero","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"07","Bordero            ?","","","mv_ch7","C",06,0,0,"G","","mv_par07","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"08","Mensagem           ?","","","mv_ch8","C",50,0,0,"G","","mv_par08","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})
AADD(aRegistros,{cPerg,"09","Segunda Mensagem   ?","","","mv_ch9","C",50,0,0,"G","","mv_par09","","","","","","","","","","","","","","","","","","","","","","","","","","","",""})                              
AADD(aRegistros,{cPerg,"10","% de Juros ao Ms  ?","","","mv_cha","N",14,2,0,"G","","mv_par10"," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "})
               
dbSelectArea("SX1")
dbSetOrder(1)
dbSeek(cPerg)              

For i:=1 to Len(aRegistros)
  If !dbSeek(cPerg+aRegistros[i,2])
     RecLock("SX1",.T.)
     For j:=1 to FCount()
       If j <= Len(aRegistros)
          FieldPut(j,aRegistros[i,j])
       Endif
     Next
     MsUnlock()
  Endif
Next
*/

// cPerguntas := Pergunte(cPerg,.T.)
Pergunte(cPerg,.T.)
                                 
_cPedOld := ""

//if cPerguntas == .T.
	ImprimeDup()
// endif

MS_FLUSH()

Return

Static Function ImprimeDup()
****************************

x := getmv("MV_BOLCEFC")
nossonum := '90'+strzero(val(x),8)

dbSelectArea("SE1")

if mv_par06 == 1
	SE1->(dbSetOrder(1))     // prefixo+numero
	SE1->(dbgotop())
	SE1->(dbSeek(xFilial("SE1")+mv_par01+mv_par02+mv_par04,.T.))
	cCondicao := "SE1->E1_FILIAL == xFilial() .And.	SE1->E1_prefixo == mv_par01 .and. se1->e1_num <= mv_par03 .and. se1->e1_PARCELA <= mv_par05"
 else
	IF  !empty(mv_par07)
		SE1->(dbSetOrder(5)) // bordero                                          
		SE1->(dbgotop())
		SE1->(dbSeek(xFilial("SE1")+mv_par07))
		cCondicao := "SE1->E1_FILIAL == xFilial() .And. SE1->E1_numbor == mv_par07"
	else
		msgbox("Nao foi preenchido o Numero do Bordero","Aviso","STOP")
	endif
endif

While &cCondicao .and. !Eof()
	
	oPrn := tAvPrinter():New( "Boleto Caixa Economica Federal" )
	oPrn :Setup()   // para configurar impressora
	
	If SE1->E1_TIPO == "IR-"
		dbSkip()
		Loop
	Endif

// pc
	If SE1->E1_PORTADO <> "104" //Caixa Economica Federal
		dbSkip()
		Loop
	Endif
    
	If SE1->E1_IMPRESS == "S"
		bImpress := MSGBOX("Imprimir novamente o titulo "+SE1->E1_NUM+"/"+SE1->E1_PARCELA+" ?","Aviso de Impressao","YESNO")
        If bImpress == .T.
           nossonum := Substr(aLLTRIM(SE1->E1_NUMBCO),1,10)                                                                 
        Endif
		if bImpress == .f.
           dbSkip()
           Loop
		endif 
	Endif	
//	If SE1->E1_PORTADO <> "104" //Caixa Economica Federal
//		dbSkip()
//		Loop
//	Endif
	     
//	If SE1->E1_IMPRESS == "S"
//		bImpress := MSGBOX("Imprimir novamente o titulo "+SE1->E1_NUM+" "+SE1->E1_PARCELA+" ?","Aviso de Impressao","YESNO")
//		if bImpress == .f.
//			dbSkip()
//			Loop
//		endif 
//	Endif

	MsgInstr01 := se1->e1_instr1
	MsgInstr02 := se1->e1_instr2
	MsgInstr03 := MV_PAR10 // juros
	MsgInstr04 := MV_PAR08 // mensagem 01
    MsgInstr05 := MV_PAR11 // multa
	MsgInstr06 := MV_PAR09 // mensagem 02
	
	SA1->(dbSeek(xFilial("SA1")+SE1->E1_CLIENTE+SE1->E1_LOJA,.f.))
	
	njuros := 0
	njuros := (MsgInstr03/30)/100
	njuros := Round(SE1->E1_VALOR * njuros,2)
	njuros := transf(njuros,"@E 999,999.99")
	
	nMulta := 0
	nMulta := (MsgInstr05)/100
	nMulta := Round(SE1->E1_VALOR * nMulta,2)
	nMulta := transf(nMulta,"@E 999,999.99")

	nDiaMes		:= ""
	nDataBase	:= ""
	nFatorVen	:= ""
	nDiaMes		:=(Strzero(day(SE1->E1_VENCREA),2)+Strzero(month(SE1->E1_VENCREA),2)) // busca dia e mes para codigo de barra
	nDiaMesAno	:=(Strzero(day(SE1->E1_VENCREA),2)+Strzero(month(SE1->E1_VENCREA),2)+subs(Strzero(year(SE1->E1_VENCREA),4),3,2))
	
	nDataBase 	:= CtoD("07/10/1997") 			// data base para calculo do fator
	nFatorVen	:= SE1->E1_vencTO - nDataBase 	// acha a diferenca em dias para o fator de vencimento
	
	nDia:=Str((SE1->E1_VENCTO - CTOD("01/01/"+Subs(STR(YEAR(SE1->E1_VENCREA),5),4,2)))+1,3)+Subs(STR(YEAR(SE1->E1_VENCREA),5),5,1)
	cLinha		:=""          

   //Busca valor do frete
    vFrete:=0
    dbSelectArea("SF2")
    dbsetorder(1)
    dbgotop()
    IF dbSeek("00"+SE1->E1_NUM+SE1->E1_PREFIXO+SE1->E1_CLIENTE+SE1->E1_LOJA,.T.)
	   vFrete := SF2->F2_FRETE
    ENDIF
    dbSelectArea("SE1")
   // fim do frete
   
	cBarra:="104"+If(SE1->E1_MOEDA==1,'9','0')+strzero(nFatorVen,4);
	+SUBS(STRZERO(SE1->E1_SALDO,16,2),6,8)+SUBS(STRZERO(SE1->E1_SALDO,16,2),15,2);
	+NOSSONUM + "0145"+ "00000000000" //e1_numbco                 #


	//agencia  cedente      carteira
	DVN := CDigitoNosso()  // calculo dos digitos verificadores do nosso numero.
	CDigitoChave()
	
	BOLLINDIG() //Calcula Linha de Digitacao
	
	oPrn:StartPage()
	oPrn:Say( 0, 0, " ",oFont,100 ) // startando a impressora

	// Imprime Logotipo do Banco                
    oPrn:Saybitmap(0054,0220,"\\SERVIDOR\DATA2\caixa1.bmp",0545,200)  // logo em anexo
	oPrn:Say ( 052, 1685, "RECIBO DO SACADO",oFont17,100)             
    oPrn:Say ( 105, 1110, "Cobrana CAIXA"  ,oFont25,100)
	oPrn:box( 0254, 200, 320, 2180)	                                     
    oPrn:Say (0260, 900, "AQUI O BRASIL ACONTECE"  ,oFont17,100)

    //        lin   col   lin   col  - Box - 1a parte
	oPrn:box( 360,  200, 1950, 2180)
	oPrn:box( 380,  220,  720, 1170) // para o cedente
	oPrn:box( 380, 1210,  720, 2160) // para o sacado
	oPrn:box( 740,  220, 1750, 2160) // para o texto 
	oPrn:box(1770,  220, 1930, 2160) // para  vencto | Valor | Autenticao
    // verticais
	oPrn:line(1770,  730, 1930,  731) // entre o vencto e o valor
	oPrn:line(1770, 1190, 1930, 1191) // entre o valor e a autenticacao
                     
    // Dados do Cedente
	oPrn:Say( 0410, 0240, "Cedente        : Empresa Cedente."  , oFont12,100)
	oPrn:Say( 0440, 0240, "Ag/Cod.Cedente : 0145.000.00000000-0"  , oFont12,100)      
	oPrn:Say( 0470, 0240, "Data Documento : " + DTOC(SE1->E1_EMISSAO) , oFont12,100)      
	oPrn:Say( 0500, 0240, "Nosso Numero   : " + NOSSONUM+"-"+DVN , oFont12,100)
	oPrn:Say( 0530, 0240, "No Documento   : " + SE1->E1_PREFIXO+" "+SE1->E1_NUM+" "+SE1->E1_PARCELA , oFont12,100)
	oPrn:Say( 0560, 0240, "Especie Doc.   : DM" , oFont12,100)
	oPrn:Say( 0590, 0240, "Carteira       : CR" , oFont12,100)
	oPrn:Say( 0620, 0240, "Aceite         : N" , oFont12,100)
	oPrn:Say( 0650, 0240, "Especie        : R$" , oFont12,100)
                
    // Dados do Sacado
	cNome   := SA1->A1_NOME
	oPrn:Say( 0440, 1240, "Sacado  : " + SE1->E1_CLIENTE + " - " + ALLTRIM(cNome), oFont12,100)
	oPrn:Say( 0480, 1240, "Endereo: " + ALLTRIM(SA1->A1_END), oFont12,100)      
	oPrn:Say( 0520, 1240, "Bairro  : " + ALLTRIM(SA1->A1_BAIRRO), oFont12,100)      
	oPrn:Say( 0560, 1240, "Cidade  : " + ALLTRIM(SA1->A1_MUN)+" - "+SA1->A1_EST, oFont12,100)
	oPrn:Say( 0600, 1240, "CEP     : " + substr(SA1->A1_CEP,1,5)+"-"+substr(SA1->A1_CEP,6,3), oFont12,100)
	
    // Textos do recibo do sacado
    oPrn:Say ( 750, 0240, "Texto de Responsabilidade do Cedente",oFont16,100)

	oPrn:Say(  800, 0240, " " ,oFont16,100  )
	oPrn:Say(  840, 0240, "MULTA DE R$  " + nMulta + "  APS : " + dtoc(SE1->E1_VENCREA),oFont16,100  )
	oPrn:Say(  880, 0240, "JUROS DE R$ "  + njuros + " AO DIA",oFont16,100  )
	oPrn:Say(  920, 0240, " " ,oFont16,100  )
	oPrn:Say(  960, 0240, "Instruo Automtica de Protesto Aps 10 Dias de Atraso" ,oFont16,100  )
	oPrn:Say( 1000, 0240, "Pagvel em Banco At 10 Dias Aps o Vencimento" ,oFont16,100  )
	oPrn:Say( 1040, 0240, " " ,oFont16,100  )
	oPrn:Say( 1080, 0240, "SR(a) CAIXA :" ,oFont16,100  )
	oPrn:Say( 1120, 0240, "ATENO PARA PRAZO DE CARTRIO" ,oFont16,100  )
	oPrn:Say( 1160, 0240, "NO RECEBER APS 10 DIAS DO VENCIMENTO" ,oFont16,100  )
	oPrn:Say( 1200, 0240, " " ,oFont16,100  )
	oPrn:Say( 1240, 0240, "Em caso de dvidas, gentileza entrar em contato :" ,oFont16,100  )
	oPrn:Say( 1280, 0240, "(35) 0000-0000 - Setor de Cobrana" ,oFont16,100  )
	oPrn:Say( 1320, 0240, " " , oFont16,100  )
	oPrn:Say( 1360, 0240, "Ref. N.F.: 0" + Substr(SE1->E1_NUM,2,5) ,oFont16,100  )
  	oPrn:Say( 1400, 0240, " " ,oFont16,100  )
	oPrn:Say( 1440, 0240, "Vendedor : (" + SE1->E1_SERIE+ ") " + SE1->E1_VEND1 + "  " + SE1->E1_VEND2 ,oFont16,100  )
	oPrn:Say( 1480, 0240, " " ,oFont16,100  )
	oPrn:Say( 1520, 0240, "Valor do Frete da NF Incluso Neste Boleto: R$ "+ TRANSF(vFrete,"@E 999,999.99"),oFont16,100  )
	oPrn:Say( 1560, 0240, " " ,oFont16,100  )
	oPrn:Say( 1600, 0240, MV_PAR08 ,oFont16,100  )
	oPrn:Say( 1640, 0240, MV_PAR09 ,oFont16,100  )
	oPrn:Say( 1680, 0240, " " ,oFont18,100  ) // 

    // Rodap do recibo do sacado
    oPrn:Say (1780, 240, "Vencimento",oFont15,100)    
	oPrn:Say( 1840, 400, DTOC(SE1->E1_VENCTO) , oFont17,100  )   //Vencimento do Titulo
    oPrn:Say (1780, 750, "Valor do Titulo",oFont15,100)
  	oPrn:Say( 1840, 900, TRANSF(SE1->E1_SALDO,"@E 999,999.99") , oFont17,100)
    oPrn:Say (1780,1210, "Autenticao Mecnica",oFont15,100)

	// **** PARTE 2 ********************************************************************************

	//+--------------------------+
	//| MONTA FICHA COMPENSAO  |
	//+--------------------------+
	
	// Monta box do boleto
	oPrn:Box (2180, 0200, 3100, 2180)
	
	// Monta linhas horizontais
	oPrn:Line(2290, 0200, 2291, 2180)
	oPrn:Line(2360, 0200, 2361, 2180)
	oPrn:Line(2430, 0200, 2431, 2180)
	oPrn:Line(2500, 0200, 2501, 2180)
	oPrn:Line(2845, 0200, 2846, 2180)
	
	// Monta linha verticais
	oPrn:Line(2100, 0550, 2180, 0551)
	oPrn:Line(2100, 0551, 2180, 0552)
	oPrn:Line(2100, 0553, 2180, 0554)
	oPrn:Line(2100, 0730, 2180, 0731)
	oPrn:Line(2100, 0731, 2180, 0732)
	oPrn:Line(2100, 0733, 2180, 0734)
	oPrn:Line(2180, 1720, 2845, 1721)
	oPrn:Line(2570, 1720, 2571, 2180)
	oPrn:Line(2640, 1720, 2641, 2180)
	oPrn:Line(2710, 1720, 2711, 2180)
	oPrn:Line(2780, 1720, 2781, 2180)
	oPrn:Line(2360, 0500, 2501, 0501)
	oPrn:Line(2360, 0900, 2501, 0901)
	oPrn:Line(2360, 1100, 2431, 1101)
	oPrn:Line(2360, 1400, 2501, 1401)
	oPrn:Line(2430, 0700, 2501, 0701)
	                                  
	// Imprime Logotipo do Banco                                                     
   oPrn:Saybitmap(2090,0220,"\\SERVIDOR\DATA2\caixa.bmp",0300,0080)   //( 2070, 0210,cBitMap,300,80 )
	oPrn:Say( 2105, 0560, "104-0"                  ,oFont21,100)
	oPrn:Say( 2105, 0745, cLinha                   ,oFont17,150)
	
	oPrn:Say( 2185, 0220, "Local de Pagamento "       ,oFont13,100  )
	oPrn:Say( 2185, 1730, "Vencimento "               ,oFont13,100  )
	oPrn:Say( 2235, 0240, "CASAS LOTERICAS, AG.CAIXA E REDE BANCARIA",oFont14,100  )   //Cedente oFont12
	oPrn:Say( 2235, 1900, DTOC(SE1->E1_VENCTO)             ,oFont15,100  )   //Vencimento do Titulo
	
	oPrn:Say( 2295, 0220, "Cedente "               ,oFont13,100  )
	oPrn:Say( 2295, 1730, "Codigo Cedente "        ,oFont13,100  )             
	
	//oPrn:Say( 2320, 0240, alltrim(sm0->m0_nomecom)	,oFont12,100  )   //Cedente	
	oPrn:Say( 2320, 0240, "Empresa Cedente"	,oFont12,100  )   //Cedente

	oPrn:Say( 2320, 1740, "0145.003.00000000-0" 	,oFont12,100 )   //Codigo do Cedente       #
	
	oPrn:Say( 2365, 0220, "Data Documento "        ,oFont13,100 )
	oPrn:Say( 2365, 0510, "N Documento "          ,oFont13,100 )
	oPrn:Say( 2365, 0910, "Especie Doc. "          ,oFont13,100 )
	oPrn:Say( 2365, 1110, "Aceite "                ,oFont13,100 )
	oPrn:Say( 2365, 1410, "Data do Processamento " ,oFont13,100 )
	oPrn:Say( 2365, 1730, "Nosso Numero "          ,oFont13,100 )
	
	oPrn:Say( 2390, 0240, DTOC(SE1->E1_EMISSAO)    ,oFont12,100  )
	oPrn:Say( 2390, 0530, SE1->E1_PREFIXO+" "+SE1->E1_NUM+" "+SE1->E1_PARCELA , oFont12,100  )
	oPrn:Say( 2390, 0970, "DM"                     ,oFont12,100  )
	oPrn:Say( 2390, 1230, "N"                      ,oFont12,100  )
	oPrn:Say( 2390, 1440, DTOC(DDATABASE)          ,oFont12,100  )
	oPrn:Say( 2390, 1880, NOSSONUM+"-"+DVN         ,oFont12,100  )
	
	oPrn:Say( 2435, 0220, "Uso do Banco "          ,oFont13,100  )
	oPrn:Say( 2435, 0510, "Carteira "			   ,oFont13,100  )
	oPrn:Say( 2435, 0710, "Especie "               ,oFont13,100  )
	oPrn:Say( 2435, 0910, "Quantidade "            ,oFont13,100  )
	oPrn:Say( 2435, 1410, "Valor "                 ,oFont13,100  )
	oPrn:Say( 2435, 1730, "Valor do Documento "    ,oFont13,100  )
	
	oPrn:Say( 2460, 0560, "CR"                     ,oFont12,100  )   //Carteira
	oPrn:Say( 2460, 0770, "R$"                     ,oFont12,100  )    
	
	oPrn:Say( 2460, 1975, TRANSF(SE1->E1_SALDO,"@E 999,999.99") , oFont12,100  )   //Codigo do Cedente
	
	oPrn:Say( 2505, 0220, "Instrues "            ,oFont13,100  )
	oPrn:Say( 2505, 1730, "(-) Desconto "          ,oFont13,100  )

	oPrn:Say( 2535, 0240, "Aps o Vcto. Cobrar multa de R$ " + nMulta + " Aps " + dtoc(SE1->E1_VENCREA),oFont18,100  )
	oPrn:Say( 2575, 0240, "Aps o Vcto. Cobrar, R$ " + njuros + " Por Dia de Atraso." ,oFont18,100  )
	oPrn:Say( 2605, 0240, "PROTESTAR APOS 10 DIAS DE ATRASO." , oFont18,100  )
	oPrn:Say( 2645, 0240, "NO RECEBER APS 10 DIAS DO VENCIMENTO." , oFont18,100  )
	oPrn:Say( 2685, 0240, "Valor do Frete da NF Incluso Neste Boleto: R$ "+ TRANSF(vFrete,"@E 999,999.99"),oFont18,100  )
	oPrn:Say( 2725, 0240, MsgInstr01               ,oFont18,100  )
	oPrn:Say( 2765, 0240, MsgInstr02               ,oFont18,100  )                 
	oPrn:Say( 2805, 0240, MsgInstr04               ,oFont18,100  )

	oPrn:Say( 2575, 1730, "(-) Outras dedues "   ,oFont13,100  )
	oPrn:Say( 2645, 1730, "(+) Mora/Multa/Juros "  ,oFont13,100  )
	oPrn:Say( 2715, 1730, "(+) Outros Acrecimos "  ,oFont13,100  )
	oPrn:Say( 2785, 1730, "(=) Valor Cobrado "     ,oFont13,100  )
	
	oPrn:Say( 2845, 0220, "Sacado"                 ,oFont13,100  )
	oPrn:Say( 2870, 0240, SE1->E1_CLIENTE + " - " + ALLTRIM(cNome) , oFont12,100  )
	oPrn:Say( 2910, 0240, "CNPJ: "+SUBS(SA1->A1_CGC,1,2)+"."+SUBS(SA1->A1_CGC,3,3)+"."+SUBS(SA1->A1_CGC,6,3)+"/"+SUBS(SA1->A1_CGC,9,4)+"-"+SUBS(SA1->A1_CGC,13,2), oFont12,100  )
	oPrn:Say( 2950, 0240, ALLTRIM(SA1->A1_END),  ,100  )
	oPrn:Say( 2990, 0240,substr(SA1->A1_CEP,1,5)+"-"+substr(SA1->A1_CEP,6,3)+"  "+ALLTRIM(SA1->A1_BAIRRO)+" - "+ALLTRIM(SA1->A1_MUN)+"   "+SA1->A1_EST, oFont12,100  )

	oPrn:Say( 3060, 0220, "Sacador/Avalista - ",oFont24,100)
	oPrn:Say( 3070, 1800, "Ficha de Compensao",oFont24,100)
	oPrn:Say( 3100, 1800, "Autenticao no Verso",oFont24,100)
	           
//ALERT(CBARRAFIM,1,44)

    MSBAR("INT25", 26.7 , 2.2 , Subs(Alltrim(cBarraFim),1,44),oPrn ,.f.,,.t.,0.025,1.3,,,) 	

    oPrn:EndPage()
	
	oPrn:End() //ORIGINAL certo
	
	xValjurmes := 0
	xValjurmes := ROUND(((mv_par10/100)/30) * SE1->E1_SALDO,2)
	
	//  GRAVACAO DO NOSSO NUMERO NO SE1
	if SE1->E1_IMPRESS # "S"
		RecLock("SE1",.F.)
		SE1->E1_NUMBCO := NOSSONUM+DVN
   // pc	SE1->E1_VLRTXJ := strzero(xValjurmes*100,12)
		SE1->E1_IMPRESS:= "S"
		MsUnLock()
		
		nossonum := STRzero(VAL(nossonum) + 1,10)
		x := STRzero(VAL(x) + 1,8)
		lNew:=.T.
	endif
 
	SE1->(dbSkip())
	Loop                                               
End
if lNew
	PUTMV("MV_BOLCEFC",STRZERO(VAL(x),8))//ANTES ERA 5
endif

RETURN(.t.)

/*/
+------------+----------+-------+-----------------------+-----------------+
|  Descricao | Faz o Calculo da Linha Digitavel.                          |
+------------+------------------------------------------------------------+
|  Uso       | BOLLINDIG                                                  |
+------------+------------------------------------------------------------+
/*/                                                   

Static FUNCTION BOLLINDIG()

//+--------------------------------------------------------------+
//| Calculo do Primeiro Campo.                                   |
//+--------------------------------------------------------------+
cLinha:=""
nDigito:=0

// banco+moeda+(nosso numero,1,5)

  // pc cCampo:=SE1->E1_PORTADO+if(SE1->E1_MOEDA==1,'9','0')+SUBS(cBarra,19,5)
  cCampo:="104"+if(SE1->E1_MOEDA==1,'9','0')+SUBS(cBarra,19,5)
  Digito()
  // pc cLinha:=cLinha+SE1->E1_PORTDEP+If(SE1->E1_MOEDA==1,'9','0')+Subs(cBarra,19,1)+"."+Subs(cBarra,20,4)+Str(nDigito,1)+Space(2)
  cLinha:=cLinha+"104"+If(SE1->E1_MOEDA==1,'9','0')+Subs(cBarra,19,1)+"."+Subs(cBarra,20,4)+Str(nDigito,1)+Space(2)


//+--------------------------------------------------------------+
// Calculo do Segundo Campo.                                    
//+--------------------------------------------------------------+
//substr(nosso numero,6,6)+agencia(4)
//cCampo:=Subs(cBarra,24,6)+"4140"
cCampo:=Subs(cBarra,24,10)
Digito()
cLinha:=cLinha+Subs(cBarra,24,5)+"."+Subs(cBarra,29,5)+Str(nDigito,1)+Space(2)
                                             
//+--------------------------------------------------------------+
// Calculo do Terceiro Campo.                                   
//+--------------------------------------------------------------+
//codigo cedente (8)+carteira(2)
cCampo:="0000000000"
Digito()
cLinha:=cLinha+"00000"+"."+"00000"+Str(nDigito,1)+Space(2) // informar codigo do banco conforme manual Cnab

//+--------------------------------------------------------------+
// Calculo do Quarto Campo.                                     
//+--------------------------------------------------------------+
// dv codigo barras + fator vencto + valor
If Val(Subs(cBarra,05,14))==0 .OR. SE1->E1_MOEDA != 1
	cCampo:="            000"
Else
	cCampo:=Str(Val(Subs(cBarra,05,14)),14)
Endif
cLinha:=cLinha+subs(cBarraFim,5,1)+" "+cCampo
li := 0 

Return(.T.)

//========================================================================
// DIGITO                                                     
//========================================================================
Static FUNCTION DIGITO()
nCont:=0
cCampo:=StrZero(Val(cCampo),10)
For i:=1 to Len(cCampo)
	If (i%2) != 0
		nCont:=nCont+(Val(Subs(cCampo,i,1))*1)
	Else
		If Val(Subs(cCampo,i,1))*2 >= 10
			nVal:=Val(Subs(cCampo,i,1))*2
			nCont:=nCont+(Val(Subs(Str(nVal,2),1,1))+Val(Subs(Str(nVal,2),2,1)))
		Else
			nCont:=nCont+(Val(Subs(cCampo,i,1))*2)
		Endif
	Endif
Next i
nDigito:=Abs(If(nCont%10==0,0,(nCont%10)-10))
Return(.t.)
// 1049546710000045295900102232001450030050225290
//========================================================================
// CDIGITOCHAVE
//========================================================================
Static Function CDigitoChave()
******************************
nCont:=0
cBarraImp 	:= space(43)
cBarraImp	:= Subs(cBarra,1,43)

CalculaModulo11()

//nCont1  := int(nCont  / 11)
//nCont2	:= ncont1 * 11
//nResto  := ncont - ncont2
nResto := MOD(ncont,11)
nDigitoImp := 11 - nResto

if nResto <= 1 .or. nResto > 9
	nDigitoImp := 1
EndIf
                                                                /// alterar  para 5,43
cBarraFim := subs(cBarra,1,4) + strzero(nDigitoImp,1) + subs(cBarra,5,48)

Return

//========================================================================
// CALCULAMODULO11
//========================================================================
Static Function CalculaModulo11
*******************************
nCont	:= 0.00
nCont	:= nCont+(Val(Subs(cBarraImp,43,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp,42,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp,41,1))*4)
nCont	:= nCont+(Val(Subs(cBarraImp,40,1))*5)
nCont	:= nCont+(Val(Subs(cBarraImp,39,1))*6)
nCont	:= nCont+(Val(Subs(cBarraImp,38,1))*7)
nCont	:= nCont+(Val(Subs(cBarraImp,37,1))*8)
nCont	:= nCont+(Val(Subs(cBarraImp,36,1))*9)
nCont	:= nCont+(Val(Subs(cBarraImp,35,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp,34,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp,33,1))*4)
nCont	:= nCont+(Val(Subs(cBarraImp,32,1))*5)
nCont	:= nCont+(Val(Subs(cBarraImp,31,1))*6)
nCont	:= nCont+(Val(Subs(cBarraImp,30,1))*7)
nCont	:= nCont+(Val(Subs(cBarraImp,29,1))*8)
nCont	:= nCont+(Val(Subs(cBarraImp,28,1))*9)

nCont	:= nCont+(Val(Subs(cBarraImp,27,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp,26,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp,25,1))*4)
nCont	:= nCont+(Val(Subs(cBarraImp,24,1))*5)
nCont	:= nCont+(Val(Subs(cBarraImp,23,1))*6)
nCont	:= nCont+(Val(Subs(cBarraImp,22,1))*7)
nCont	:= nCont+(Val(Subs(cBarraImp,21,1))*8)
nCont	:= nCont+(Val(Subs(cBarraImp,20,1))*9)
nCont	:= nCont+(Val(Subs(cBarraImp,19,1))*2)

nCont	:= nCont+(Val(Subs(cBarraImp,18,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp,17,1))*4)
nCont	:= nCont+(Val(Subs(cBarraImp,16,1))*5)
nCont	:= nCont+(Val(Subs(cBarraImp,15,1))*6)
nCont	:= nCont+(Val(Subs(cBarraImp,14,1))*7)
nCont	:= nCont+(Val(Subs(cBarraImp,13,1))*8)

nCont	:= nCont+(Val(Subs(cBarraImp,12,1))*9)
nCont	:= nCont+(Val(Subs(cBarraImp,11,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp,10,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp,09,1))*4)
nCont	:= nCont+(Val(Subs(cBarraImp,08,1))*5)
nCont	:= nCont+(Val(Subs(cBarraImp,07,1))*6)

nCont	:= nCont+(Val(Subs(cBarraImp,06,1))*7)
nCont	:= nCont+(Val(Subs(cBarraImp,05,1))*8)
nCont	:= nCont+(Val(Subs(cBarraImp,04,1))*9)
nCont	:= nCont+(Val(Subs(cBarraImp,03,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp,02,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp,01,1))*4)

Return

//========================================================================
// CDIGITONOSS0
//========================================================================
Static Function CDigitoNosso()
******************************
nCont:=0
cBarraImp3 	:= space(11)
cBarraImp3	:= nossonum  // Subs(cBarra,19,11)
CalNosso()
nCont1  := int(nCont  / 11)
nCont2	:= ncont1 * 11
nResto  := ncont - ncont2
nResto  := 11 - nResto
if nResto > 9
	nResto := 0
	cBarraImp4 := cBarraImp3+"0"
	Return("0")
else
	cBarraImp4 := cBarraImp3 + strzero(nResto,1)
	Return(strzero(nResto,1))
EndIf

//========================================================================
// CALCNOSSO
//========================================================================
Static Function CalNosso
*******************************
nCont	:= 0
//nCont	:= nCont+(Val(Subs(cBarraImp3,11,1))*9)
nCont	:= nCont+(Val(Subs(cBarraImp3,10,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp3,09,1))*3)
nCont	:= nCont+(Val(Subs(cBarraImp3,08,1))*4)
nCont	:= nCont+(Val(Subs(cBarraImp3,07,1))*5)
nCont	:= nCont+(Val(Subs(cBarraImp3,06,1))*6)
nCont	:= nCont+(Val(Subs(cBarraImp3,05,1))*7)
nCont	:= nCont+(Val(Subs(cBarraImp3,04,1))*8)
nCont	:= nCont+(Val(Subs(cBarraImp3,03,1))*9)
nCont	:= nCont+(Val(Subs(cBarraImp3,02,1))*2)
nCont	:= nCont+(Val(Subs(cBarraImp3,01,1))*3)

Return